package de.tudarmstadt.informatik.hostage.logging;

import java.util.ArrayList;

import android.content.Context;

public class SQLLogger implements Logger{
	Context context;
	DatabaseHandler dbh;
	
	public SQLLogger(Context context){
		this.context = context;
		dbh = new DatabaseHandler(context);	
	}

	@Override
	public synchronized void write(Record record) {
		dbh.addRecord(record);
	}

	@Override
	public ArrayList<Record> getAllRecords() {
		return dbh.getAllRecords();
	}

	@Override
	public ArrayList<Record> getRecordOfEachAttack(int lastUploadedAttackId) {
		return dbh.getRecordOfEachAttack(lastUploadedAttackId);
	}

	@Override
	public Record getRecordOfAttackId(long attack_id) {
		return dbh.getRecordOfAttackId(attack_id);
	}

	@Override
	public int getAttackCount() {
		return dbh.getAttackCount();
	}

	@Override
	public int getAttackPerProtokolCount(String protocol) {
		return dbh.getAttackPerProtokolCount(protocol);
	}

	@Override
	public long getSmallestAttackId() {
		return dbh.getSmallestAttackId();
	}

	@Override
	public long getHighestAttackId() {
		return dbh.getHighestAttackId();
	}

	@Override
	public boolean bssidSeen(String protocol, String bssid) {
		return dbh.bssidSeen(protocol, bssid);
	}

	@Override
	public String[] getAllBSSIDS() {
		return dbh.getAllBSSIDS();
	}

	@Override
	public String getSSID(String bssid) {
		return dbh.getSSID(bssid);
	}

	@Override
	public void deleteByDate(long time) {
		dbh.deleteByDate(time);		
	}

	@Override
	public void deleteByBSSID(String bssid) {
		dbh.deleteByBSSID(bssid);
	}

	@Override
	public void clearData() {
		dbh.clearData();
	}
}
